//Program do wyznacznia najczciej wystpujcej wartoci w tablicy (dominaty)
//Micha Witaszek
//dla algorytm.org

#include <iostream>
#include <stdlib.h>

using namespace std;

int main()
{

  int T[100];            // Tablica bdzie przechowywaa zadany zbir liczb
  int lista[100];        // Lista liczb wystpujcych w zbiorze
  int wystepowanie[100]; // Zapamita ile razy liczby pojawiaj si w zbiorze
  int n;                     
  int i,j;               // Bd suyy jako indeksy tablic
  bool znaleziono;       // Podczas przeszukiwania tablic bdzie okrelaa czy liczba ju zajduje si na licie

  int dlugosc_listy=0;         

  const string separator = "--------------------------- \n";

start:
// Pobranie od uytkownika iloci elementw tablicy

  cout << "Ilosc elementow tablicy: ";
  cin >> n;

if (n<=0 || n>100) 
    {
    cout << "Podaj wartosc z akresu 1-100 \n";
    goto start;
    }
    
 cout << separator;
 
// Odczytywanie n elementw tablicy
 for (i=0; i<n; i++)
    {
      cout << "Wartosc nr " << i+1 << ": ";
      cin >> T[i];
    }

// Przeszukiwanie zadanej tablicy T[]
   for (i=0; i<n; i++) 
    {
      j=0;
      znaleziono= false;

// Przeszukuje list liczb a znajdzie w niej aktualnie odczytan warto z tablicy T[]
// lub osignie koniec listy

      for (j=0; j<dlugosc_listy; j++)
      {
        if (lista[j]==T[i]) //Jeli liczba znajduje si na licie...
          {
          wystepowanie[j]++; // Zwiksz ilo wystpie liczby o 1
          znaleziono= true; // Zapamitaj e odnaleziono liczb.
          }
        if (znaleziono) break;
      }  
      

      if (!znaleziono) //Jeli liczba nie znajduje si jeszcze na licie...
        {
          dlugosc_listy++;          
          lista[dlugosc_listy-1]=T[i]; //Wstaw liczb na ostani pozycje w licie
          wystepowanie[dlugosc_listy-1]=1; //Ustaw ilo wystpie liczby na 1
        }	   
	  } 

  cout << separator;

  
    //Dla przejystoci program wypisze iloi wystpie wszystkich liczb.
    for (i=0; i<dlugosc_listy; i++)  {cout << lista[i] << " x " << wystepowanie[i] << endl;}

  cout << separator;

    //Szukanie najczciej wystpujcej liczby
    i=0; 
    j=0;
   
    for (i=1; i<dlugosc_listy; i++)  //Przeszukanie tablicy wystpowania liczb
    {
     //Jeli liczba wystpie jest wiksza od poprzednio znalezionej...
        if (wystepowanie[i] >= wystepowanie[j]) j=i; // zapamitaj indeks liczby.
    } 

   //Wypisz wynik
    cout << "Dominanta jest liczba " << lista[j] << endl;
    cout << "Pojawia sie " << wystepowanie[j] << " razy." << endl;  
  
//Czekaj na ANYKEY
  system("PAUSE");	
//i zamknij program
  return 0;
}